#include <OneWire.h> 

int DS18S20_Pin = 2; //DS18S20 Signal pin on digital 2
OneWire ds(DS18S20_Pin);
int relay = 7;//////////////////If need to control any AC components
int photoCellPin = A2;
int photoReading;
boolean day = true;
boolean cold = true;
boolean doorClosed = false;
int CloseButtonPushed = 4;
int OpenButtonPushed = 3;
int OpenButtonPushed2 = 5
int opened;
int opened2;
int closed;


void setup() {
 Serial.begin(9600);
 pinMode(relay, OUTPUT);
 pinMode(8, OUTPUT);
 pinMode(9, OUTPUT);
 pinMode(10, OUTPUT);
 pinMode(CloseButtonPushed, INPUT);
 pinMode(OpenButtonPushed, INPUT);
 pinMode(OpenButtonPushed2, INPUT);
}

void loop() {
  //Serial.println("Checking");
  photoReading = analogRead(photoCellPin);
  float temperature = getTemp();
  float temp = temperature * 9 /5 + 32;
  Serial.println(temp);
  
  if(analogRead(photoCellPin) < 20 && day == true){//check if it is dark enough to close the door
    delay(10000);
    if(analogRead(photoCellPin) < 20){//check again after 10 seconds just in case something coveres the sensor
      nightTime();
    }
  }
  
  if(photoReading > 25 && temp > 40 && day == false){//check if it is light and warm enough to open the door
    delay(10000);
    dayTime();
  }
  
//******************Turn on heat lamp*************************
  if(temp <= 30 && cold == true){
    //digitalWrite(relay, HIGH);//////////////////If need to control any AC components
    cold = false;
  }else if(temp > 30 && cold == false){
    //digitalWrite(relay, LOW);//////////////////If need to control any AC components
    cold = true;
  }

//******************Turn on Fan********************************
  if(temp >= 70 && cold == false){
    //digitalWrite(relay, HIGH);//////////////////If need to control any AC components
    cold = true;
  }else if(temp <= 68 && cold == true){
    //digitalWrite(relay, LOW);//////////////////If need to control any AC components
    cold = false;
  }
  delay(1);
}

void dayTime(){
  day = true;
  //digitalWrite(relay, HIGH);//////////////////If need to control any AC components
  while(doorStatusOpened() != 1 || doorStatusOpened2() != 1){//if open door sensors arent clicked then open the door until they are
  Serial.print("\n Day Time");
  digitalWrite(9, LOW);
  digitalWrite(8, HIGH);
  analogWrite(10, 255);
  }
  digitalWrite(8, LOW);
  return;
}

void nightTime(){
  day = false;
  //digitalWrite(relay, HIGH);//////////////////If need to control any AC components
  while(doorStatusClosed() != 1){//if the closed door sensor isnt clicked them close the door until it is
  Serial.print("\n Night Time");
  digitalWrite(9, HIGH);
  digitalWrite(8, LOW);
  analogWrite(10, 255);
  }
  digitalWrite(9, LOW);
  return;
}

int doorStatusOpened(){
  opened = digitalRead(OpenButtonPushed);
  return opened;
}
int doorStatusOpened2(){
  opened2 = digitalRead(OpenButtonPushed2);
  return opened2;
}
int doorStatusClosed(){
  closed = digitalRead(CloseButtonPushed);
  return closed;
}

float getTemp(){
 //returns the temperature from one DS18S20 in DEG Celsius

 byte data[12];
 byte addr[8];

 if ( !ds.search(addr)) {
   //no more sensors on chain, reset search
   ds.reset_search();
   return -1000;
 }

 if ( OneWire::crc8( addr, 7) != addr[7]) {
   Serial.println("CRC is not valid!");
   return -2000;
 }

 if ( addr[0] != 0x10 && addr[0] != 0x28) {
   Serial.print("Device is not recognized");
   return -3000;
 }

 ds.reset();
 ds.select(addr);
 ds.write(0x44,1); // start conversion, with parasite power on at the end

 byte present = ds.reset();
 ds.select(addr);  
 ds.write(0xBE); // Read Scratchpad

 
 for (int i = 0; i < 9; i++) { // we need 9 bytes
  data[i] = ds.read();
 }
 
 ds.reset_search();
 
 byte MSB = data[1];
 byte LSB = data[0];

 float tempRead = ((MSB << 8) | LSB); //using two's compliment
 float TemperatureSum = tempRead / 16;
 
 return TemperatureSum;
 
}
